'ProgEx40g -- PowerBASIC 9.02 Version Of Our BoxVolume/Form3 Program With Extensive Subclassing
'
'             In this PowerBASIC version of the program I subclassed the Length, Width, and
'             Height text boxes, and the Calculate and Display buttons.  Also, I added a 
'             Clear button and subclassed that too.  In addition, I added some simple data
'             entry validation to the text boxes in that they will no longer accept non-
'             numeric input.  
'
'             Due to the subclassing, you can now use the [ENTER] key to navigate through the
'             controls, as well as the up and down arrow keys.
'
#Compile Exe
#Include "Win32api.inc"
#Include "BoxVolume.inc"
#Include "frmOutput.inc"

Function fnEditSubClass_OnKeyPress(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local iCtrlId,hParent As Dword
  
  Select Case As Long wParam
    Case 9, 13 '[TAB], [ENTER]
      iCtrlId=GetDlgCtrlID(hWnd)
      hParent=GetParent(hWnd)
      Select Case As Long iCtrlId
        Case %IDC_EDIT_LENGTH
          Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_WIDTH))
          Exit Function
        Case %IDC_EDIT_WIDTH
          Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_HEIGHT))
          Exit Function
        Case %IDC_EDIT_HEIGHT
          Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_CALCULATE))
          Exit Function
      End Select
    Case 46
      Function=CallWindowProc(fnEditWndProc,hWnd,wMsg,wParam,lParam)
      Exit Function
    Case 48 To 57
      Function=CallWindowProc(fnEditWndProc,hWnd,wMsg,wParam,lParam)
      Exit Function
  End Select 

  Function=0  
End Function


Function fnEditSubClass_OnKeyDown(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local hParent As Dword

  hParent=GetParent(hWnd)
  Select Case As Long GetDlgCtrlID(hWnd)
    Case %IDC_EDIT_LENGTH
      Select Case As Long wParam
        Case %VK_UP
          Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_CLEAR))
          Function=0 : Exit Function
        Case %VK_DOWN
          Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_WIDTH))
          Function=0 : Exit Function
      End Select 
    Case %IDC_EDIT_WIDTH
      Select Case As Long wParam
        Case %VK_UP
          Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_LENGTH))
          Function=0 : Exit Function
        Case %VK_DOWN
          Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_HEIGHT))
          Function=0 : Exit Function
      End Select 
    Case %IDC_EDIT_HEIGHT
      Select Case As Long wParam
        Case %VK_UP
          Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_WIDTH))
          Function=0 : Exit Function
        Case %VK_DOWN
          Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_CALCULATE))
          Function=0 : Exit Function
      End Select  
  End Select 
   
  Function=CallWindowProc(fnEditWndProc,hWnd,wMsg,wParam,lParam)
End Function


Function fnButtonSubClass_OnKeyPress(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local hParent As Dword
  
  hParent=GetParent(hWnd)
  If wParam=9 Or wParam=13 Then
     If wParam=13 Then
        Call SendMessage(hWnd,%BM_CLICK,0,0)
     End If 
     Select Case As Long GetDlgCtrlID(hWnd)
       Case %IDC_BUTTON_CALCULATE
         Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_DISPLAY))
         Function=0 : Exit Function
       Case %IDC_BUTTON_DISPLAY
         Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_CLEAR))
         Function=0 : Exit Function
       Case %IDC_BUTTON_CLEAR  
         Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_LENGTH))
         Function=0 : Exit Function
     End Select
  End If 
  
  Function=CallWindowProc(fnButtonWndProc,hWnd,wMsg,wParam,lParam)
End Function


Function fnButtonSubClass_OnKeyDown(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Local hParent As Dword

  hParent=GetParent(hWnd)
  Select Case As Long GetDlgCtrlID(hWnd)
    Case %IDC_BUTTON_CALCULATE
      Select Case As Long wParam
        Case %VK_UP
          Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_HEIGHT))
          Function=0 : Exit Function
        Case %VK_DOWN
          Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_DISPLAY))
          Function=0 : Exit Function
      End Select 
    Case %IDC_BUTTON_DISPLAY
      Select Case As Long wParam
        Case %VK_UP
          Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_CALCULATE))
          Function=0 : Exit Function
        Case %VK_DOWN
          Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_CLEAR))
          Function=0 : Exit Function
      End Select 
    Case %IDC_BUTTON_CLEAR
      Select Case As Long wParam
        Case %VK_UP
          Call SetFocus(GetDlgItem(hParent,%IDC_BUTTON_DISPLAY))
          Function=0 : Exit Function
        Case %VK_DOWN
          Call SetFocus(GetDlgItem(hParent,%IDC_EDIT_LENGTH))
          Function=0 : Exit Function
      End Select  
  End Select 

  Function=CallWindowProc(fnButtonWndProc,hWnd,wMsg,wParam,lParam)
End Function


Function fnEditSubClass(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Select Case As Long wMsg
    Case %WM_CHAR
      Function=fnEditSubClass_OnKeyPress(hWnd,wMsg,wParam,lParam)
      Exit Function
    Case %WM_KEYDOWN
      Function=fnEditSubClass_OnKeyDown(hWnd,wMsg,wParam,lParam)
      Exit Function
  End Select

  Function=CallWindowProc(fnEditWndProc,hWnd,wMsg,wParam,lParam)
End Function


Function fnButtonSubClass(ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Select Case As Long wMsg
    Case %WM_CHAR
      Function=fnButtonSubClass_OnKeyPress(hWnd,wMsg,wParam,lParam)
    Case %WM_KEYDOWN
      Function=fnButtonSubClass_OnKeyDown(hWnd,wMsg,wParam,lParam)
  End Select

  Function=CallWindowProc(fnButtonWndProc,hWnd,wMsg,wParam,lParam)
End Function


Function fnWndProc_OnCreate(Wea As WndEventArgs) As Long
  Local pCreateStruct As CREATESTRUCT Ptr
  Local szClassName As Asciiz*16
  Local szBuffer() As Asciiz*16
  Local hCtl,dwStyle As Dword
  Local wc As WNDCLASSEX
  Register i As Long
  
  pCreateStruct=Wea.lParam
  Wea.hInst=@pCreateStruct.hInstance
  dwStyle=%WS_CHILD Or %WS_VISIBLE
  Redim szBuffer(4) As Asciiz*16
  szBuffer(0)="Ordinary Box" : szBuffer(1)="Box Of Junk" : szBuffer(2)="Beer Crate" : szBuffer(3)="Wine Box" : szBuffer(4)="Candy Box"
  hCtl=CreateWindow("static","Choose Kind of Box",%WS_CHILD Or %WS_VISIBLE,10,10,140,25,Wea.hWnd,-1,Wea.hInst,Byval 0)
  hCtl=CreateWindow("combobox","",dwStyle Or %CBS_DROPDOWNLIST Or %WS_VSCROLL,150,10,140,100,Wea.hWnd,%IDC_COMBO_TYPE,Wea.hInst,Byval 0)
  For i=0 To 4
    SendMessage(hCtl,%CB_INSERTSTRING,-1,Varptr(szBuffer(i)))
  Next i 
  SendMessage(hCtl,%CB_SETCURSEL,0,0) 
  Erase szBuffer 
  hCtl=CreateWindow("static","Length of Box",%WS_CHILD Or %WS_VISIBLE,10,53,125,25,Wea.hWnd,-1,Wea.hInst,Byval 0)
  hCtl=CreateWindowEx(%WS_EX_CLIENTEDGE,"edit","",dwStyle,150,50,70,25,Wea.hWnd,%IDC_EDIT_LENGTH,Wea.hInst,Byval 0)
  fnEditWndProc=SetWindowLong(hCtl,%GWL_WNDPROC,CodePtr(fnEditSubClass))
  hCtl=CreateWindow("static","Width of Box",%WS_CHILD Or %WS_VISIBLE,10,93,125,25,Wea.hWnd,-1,Wea.hInst,Byval 0)
  hCtl=CreateWindowEx(%WS_EX_CLIENTEDGE,"edit","",dwStyle,150,90,70,25,Wea.hWnd,%IDC_EDIT_WIDTH,Wea.hInst,Byval 0)
  fnEditWndProc=SetWindowLong(hCtl,%GWL_WNDPROC,CodePtr(fnEditSubClass))
  hCtl=CreateWindow("static","Height of Box",%WS_CHILD Or %WS_VISIBLE,10,133,125,25,Wea.hWnd,-1,Wea.hInst,Byval 0)
  hCtl=CreateWindowEx(%WS_EX_CLIENTEDGE,"edit","",dwStyle,150,130,70,25,Wea.hWnd,%IDC_EDIT_HEIGHT,Wea.hInst,Byval 0)
  fnEditWndProc=SetWindowLong(hCtl,%GWL_WNDPROC,CodePtr(fnEditSubClass))
  hCtl=CreateWindow("static","Volume",%WS_CHILD Or %WS_VISIBLE,10,183,50,25,Wea.hWnd,-1,Wea.hInst,Byval 0)
  hCtl=CreateWindowEx(%WS_EX_CLIENTEDGE,"edit","",dwStyle,60,180,335,25,Wea.hWnd,%IDC_EDIT_VOLUME,Wea.hInst,Byval 0)
  hCtl=CreateWindow("button","Calculate",dwStyle,245,48,120,30,Wea.hWnd,%IDC_BUTTON_CALCULATE,Wea.hInst,Byval 0)
  fnButtonWndProc=SetWindowLong(hCtl,%GWL_WNDPROC,CodePtr(fnButtonSubClass))
  hCtl=CreateWindow("button","Display",dwStyle,245,88,120,30,Wea.hWnd,%IDC_BUTTON_DISPLAY,Wea.hInst,Byval 0)
  fnButtonWndProc=SetWindowLong(hCtl,%GWL_WNDPROC,CodePtr(fnButtonSubClass))
  hCtl=CreateWindow("button","Clear",dwStyle,245,128,120,30,Wea.hWnd,%IDC_BUTTON_CLEAR,Wea.hInst,Byval 0)
  fnButtonWndProc=SetWindowLong(hCtl,%GWL_WNDPROC,CodePtr(fnButtonSubClass))
  Call SetWindowText(Wea.hWnd,"Box Volume With Child Control Subclassing")
  
  'Register Output Screen Class
  szClassName="Output"
  wc.lpszClassName=Varptr(szClassName)                 :  wc.lpfnWndProc=CodePtr(fnOutputProc)
  wc.cbSize=Sizeof(WNDCLASSEX)                         :  wc.style=%CS_DBLCLKS
  wc.hIcon=LoadIcon(%NULL,ByVal %IDI_APPLICATION)      :  wc.hInstance=Wea.hInst
  wc.hIconSm=LoadIcon(%NULL, ByVal %IDI_APPLICATION)   :  wc.hCursor=LoadCursor(%NULL,ByVal %IDC_ARROW)
  wc.hbrBackground=GetStockObject(%WHITE_BRUSH)        :  wc.cbWndExtra=4
  wc.lpszMenuName=%NULL                                :  wc.cbClsExtra=0
  Call RegisterClassEx(wc)
   
  fnWndProc_OnCreate=0
End Function


Function btnCalculate_OnClick(Wea As WndEventArgs) As Long
  Local szBuffer As Asciiz*64
  Local bx As CBox
  
  Call GetWindowText(GetDlgItem(Wea.hWnd,%IDC_EDIT_LENGTH),szBuffer,64) : bx.dblLength=Val(szBuffer)
  Call GetWindowText(GetDlgItem(Wea.hWnd,%IDC_EDIT_WIDTH),szBuffer,64)  : bx.dblWidth=Val(szBuffer)
  Call GetWindowText(GetDlgItem(Wea.hWnd,%IDC_EDIT_HEIGHT),szBuffer,64) : bx.dblHeight=Val(szBuffer)
  Call GetWindowText(GetDlgItem(Wea.hWnd,%IDC_COMBO_TYPE),bx.szBoxType,16)
  bx.dblVolume = bx.dblLength * bx.dblWidth * bx.dblHeight
  szBuffer="The Volume Of Your " & bx.szBoxType & " Is " & Str$(bx.dblVolume) & "."
  Call SetWindowText(GetDlgItem(Wea.hWnd,%IDC_EDIT_VOLUME),szBuffer)                                              

  Function=0
End Function



Function btnDisplay_OnClick(Wea As WndEventArgs) As Long
  Local szBuffer As Asciiz * 64
  Local hIns,hOutput As Dword
  Local bx As CBox
   
  Call GetWindowText(GetDlgItem(Wea.hWnd,%IDC_EDIT_LENGTH),szBuffer,64) : bx.dblLength=Val(szBuffer)
  Call GetWindowText(GetDlgItem(Wea.hWnd,%IDC_EDIT_WIDTH),szBuffer,64)  : bx.dblWidth=Val(szBuffer)
  Call GetWindowText(GetDlgItem(Wea.hWnd,%IDC_EDIT_HEIGHT),szBuffer,64) : bx.dblHeight=Val(szBuffer)
  Call GetWindowText(GetDlgItem(Wea.hWnd,%IDC_COMBO_TYPE),bx.szBoxType,16)
  bx.dblVolume = bx.dblLength * bx.dblWidth * bx.dblHeight
  hIns=GetModuleHandle("")
  hOutput=CreateWindow("Output","Output Screen",%WS_OVERLAPPEDWINDOW,650,300,350,200,0,0,hIns,Byval Varptr(bx))
  Call ShowWindow(hOutput,%SW_SHOWNORMAL)
  
  Function=0
End Function


Function btnClear_OnClick(Wea As WndEventArgs) As Long
  Local hEdit As Dword

  hEdit=GetDlgItem(Wea.hWnd,%IDC_EDIT_WIDTH)
  Call SetWindowText(hEdit,"")
  hEdit=GetDlgItem(Wea.hWnd,%IDC_EDIT_HEIGHT)
  SetWindowText(hEdit,"")
  hEdit=GetDlgItem(Wea.hWnd,%IDC_EDIT_VOLUME)
  SetWindowText(hEdit,"")
  hEdit=GetDlgItem(Wea.hWnd,%IDC_EDIT_LENGTH)
  SetWindowText(hEdit,"")
  SetFocus(hEdit)

  Function=0
End Function


Function fnWndProc_OnCommand(Wea As WndEventArgs) As Long
  Select Case As Long Lowrd(Wea.wParam)
    Case %IDC_BUTTON_CALCULATE
      Call btnCalculate_OnClick(Wea)
    Case %IDC_BUTTON_DISPLAY  
      Call btnDisplay_OnClick(Wea)
    Case %IDC_BUTTON_CLEAR
      Call btnClear_OnClick(Wea)  
  End Select  
    
  fnWndProc_OnCommand=0
End Function


Function fnWndProc_OnClose(wea As WndEventArgs) As Long
  Local hOutput As Dword
  
  Do 
     hOutput=FindWindowEx(0,0,"Output","Output Screen")
     If hOutput Then
        Call SendMessage(hOutput,%WM_CLOSE,0,0)
     Else
        Exit Do
     End If   
  Loop
  Call PostQuitMessage(0)
  
  fnWndProc_OnClose=0
End Function


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) As Long
  Static wea As WndEventArgs
  Register iReturn As Long
  Register i As Long

  For i=0 To 2
    If wMsg=MsgHdlr(i).wMessage Then
       wea.hWnd=hWnd: wea.wParam=wParam: wea.lParam=lParam
       Call Dword MsgHdlr(i).dwFnPtr Using FnPtr(wea) To iReturn
       fnWndProc=iReturn
       Exit Function
    End If
  Next i

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Sub AttachMessageHandlers()               'Associate Windows Message With Message Handlers
  ReDim OutputHdlr(2) As MessageHandler
  Redim MsgHdlr(2) As MessageHandler
   
  MsgHdlr(0).wMessage=%WM_CREATE      :   MsgHdlr(0).dwFnPtr=CodePtr(fnWndProc_OnCreate)
  MsgHdlr(1).wMessage=%WM_COMMAND     :   MsgHdlr(1).dwFnPtr=CodePtr(fnWndProc_OnCommand)
  MsgHdlr(2).wMessage=%WM_CLOSE       :   MsgHdlr(2).dwFnPtr=CodePtr(fnWndProc_OnClose)
  OutputHdlr(0).wMessage=%WM_CREATE   :   OutputHdlr(0).dwFnPtr=CodePtr(fnOutputProc_OnCreate)
  OutputHdlr(1).wMessage=%WM_PAINT    :   OutputHdlr(1).dwFnPtr=CodePtr(fnOutputProc_OnPaint)
  OutputHdlr(2).wMessage=%WM_CLOSE    :   OutputHdlr(2).dwFnPtr=CodePtr(fnOutputProc_OnClose)
End Sub


Function WinMain(ByVal hIns As Long,ByVal hPrev As Long,ByVal lpCL As Asciiz Ptr,ByVal iShow As Long) As Long
  Local szAppName As Asciiz*16
  Local wc As WndClassEx
  Local hWnd As Dword
  Local Msg As tagMsg

  szAppName="Form3"                               : Call AttachMessageHandlers()
  wc.lpszClassName=VarPtr(szAppName)              : wc.lpfnWndProc=CodePtr(fnWndProc)
  wc.cbClsExtra=0                                 : wc.cbWndExtra=0
  wc.style=%CS_HREDRAW Or %CS_VREDRAW             : wc.hInstance=hIns
  wc.cbSize=SizeOf(wc)                            : wc.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wc.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)  : wc.hbrBackground=%COLOR_BTNFACE+1
  wc.lpszMenuName=%NULL
  Call RegisterClassEx(wc)
  hWnd=CreateWindow(szAppName,"Form3",%WS_OVERLAPPEDWINDOW,100,400,410,250,0,0,hIns,ByVal 0)
  Call ShowWindow(hWnd,iShow)
  While GetMessage(Msg,%NULL,0,0)
    Call TranslateMessage(Msg)
    Call DispatchMessage(Msg)
  Wend

  Function=msg.wParam
End Function
